<script setup lang="ts">
import { AppError } from '@/scripts/types'
import { useAppStore } from '@/store/app'
import QrScanner from 'qr-scanner'
import { onMounted } from 'vue'

const app = useAppStore()

const emit = defineEmits(['scan'])

onMounted(() => {
  const video = document.getElementById('video') as HTMLVideoElement

  const scanner = new QrScanner(video, (result: QrScanner.ScanResult) => {
    emit('scan', result.data)
  }, {
    highlightScanRegion: true,
    highlightCodeOutline: true,
  })
  scanner.start().then(() => {
    console.log('Scanner started !')
  }).catch(err => {
    app.displayError(AppError.QRCodeError, err)
  })
})
</script>

<template>
    <div id="video-div">
        <video id="video"></video>
    </div>
</template>

<style scoped>

#video-div {
  display: flex;
  background-color: lightslategrey;
  border: 3px dashed lightslategrey;
  border-radius: 15px;
  overflow: hidden;
}

#video {
  object-fit: cover;
}

</style>
